package com.fdkankan.ucenter.exception;

import com.fdkankan.common.exception.BusinessException;
import com.fdkankan.ucenter.common.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * 全局异常处理器
 */
@RestControllerAdvice
@Slf4j
public class GlobalExceptionHandler {

    /**
     * 处理未知异常
     */
    @ResponseBody
    @ExceptionHandler(value = Exception.class)
    public Result exceptionHandler(Exception e) throws Exception {
        log.error("服务错误:", e);
        return Result.failure( 500, e.getMessage());
    }

    /**
     * 处理业务异常
     */
    @ResponseBody
    @ExceptionHandler(value = BusinessException.class)
    public Result businessExceptionHandler(BusinessException e) {
        return Result.failure(e.getCode(), e.getMessage());
    }

    /**
     * 处理业务异常
     */
    @ResponseBody
    @ExceptionHandler(value = com.fdkankan.ucenter.exception.BusinessException.class)
    public Result businessExceptionHandler2(com.fdkankan.ucenter.exception.BusinessException e) {
        return Result.failure(e.getCode(), e.getMessage());
    }
}
